uses
  SysUtils, testlib;

  function GCD(a, b: Integer): Integer;
  begin
    while (a > 0) and (b > 0) do
      if a > b then a := a mod b else b := b mod a;
    Result := a + b;
  end;

var
  i, N, cnt, v, g: Integer;
  found, zero: Boolean;
  a: array of Integer;
begin
  N := inf.ReadInteger;
  SetLength(a, N);
  for i := 0 to High(a) do
    a[i] := inf.ReadInteger;

  zero := false;
  g := 0; cnt := 0;
  while not ouf.SeekEof do begin
    v := ouf.ReadInteger;
    if v < -1 then Quit(_PE, IntToStr(v));
    if v = -1 then begin
      if cnt > 0 then Quit(_PE, '-1 not at start');
      if ans.ReadInteger <> -1 then Quit(_WA, '-1 but should be possible');
      Quit(_OK, '');
    end;
    if v = 0 then begin
      if zero then Quit(_WA, 'More than one zero');
      if g = 0 then Quit(_WA, 'Empty first group');
      if g = 1 then Quit(_WA, 'GCD = 1 for the first group');
      g := 0;
      zero := true;
      continue;
    end;
    found := false;
    for i := 0 to High(a) do begin
      if a[i] = v then begin
        a[i] := 0;
        found := true;
        break;
      end;
    end;
    if not found then Quit(_WA, Format('Number %d not found', [v]));
    g := GCD(g, v);
    Inc(cnt);
  end;
  if (g = 0) or not zero then Quit(_WA, 'Empty second group');
  if g = 1 then Quit(_WA, 'GCD = 1 for the second group');
  if cnt <> Length(a) then Quit(_WA, 'Not all numbers used');
  Quit(_OK, '');
end.
