{$R+}
uses
  Math, SysUtils;

  function GCD(a, b: Integer): Integer;
  begin
    while (a > 0) and (b > 0) do
      if a > b then a := a mod b else b := b mod a;
    Result := a + b;
  end;

var
  f: TextFile;
  a: array of Integer;
  b: array of Boolean;
  i, j, g1, g2, N, t: Integer;
  found: Boolean = false;
begin
  Assign(f, 'input.txt'); Reset(f);
  Read(f, N);
  SetLength(a, N);
  SetLength(b, N);
  for i := 0 to High(a) do Read(f, a[i]);
  CloseFile(f);

  g1 := 0; g2 := 0; found := true;
  for j := 0 to High(a) do begin
    t := GCD(g1, a[j]);
    b[j] := t > 1;
    if b[j] then
      g1 := t
    else begin
      t := GCD(g2, a[j]);
      found := t > 1;
      if not found then break;
      g2 := t;
    end;
  end;

  Assign(f, 'output.txt'); Rewrite(f);
  if found then begin
    if g2 = 0 then
      b[0] := false;
    for j := 0 to High(a) do
      if b[j] then Write(f, a[j], ' ');
    Writeln(f, 0);
    for j := 0 to High(a) do
      if not b[j] then Write(f, a[j], ' ');
  end
  else
    Writeln(f, -1);
  CloseFile(f);
end.
